<?php



// Bootstrap file for getting the ABSPATH constant to wp-load.php

require_once('../../config.php');



// check for rights

if ( !is_user_logged_in() || !current_user_can('edit_posts') ) 

	wp_die(__("You are not allowed to be here"));

?>



<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>

<title>Insert Content Boxes</title>

<script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/1.6.1/jquery.js"></script>

<script language="javascript" type="text/javascript" src="<?php echo home_url(); ?>/wp-includes/js/tinymce/tiny_mce_popup.js"></script>

<style type="text/css" src="<?php echo home_url(); ?>/wp-includes/js/tinymce/themes/advanced/skins/wp_theme/dialog.css"></style>

<script type="text/javascript" src="<?php echo home_url(); ?>/wp-content/plugins/wp-graphix-magic-light/includes/js/wpgfxm-jscolor/jscolor.js"></script>

<link rel="stylesheet" type="text/css" href="<?php echo home_url(); ?>/wp-content/plugins/wp-graphix-magic-light/includes/contentboxes/contentboxes-tinymce.css" />



<script type="text/javascript">

 var ButtonDialog = {

	local_ed : 'ed',

	init : function(ed) {

		ButtonDialog.local_ed = ed;

		tinyMCEPopup.resizeToInnerSize();

	},

	insert : function insertButton(ed) {

 

		// set up variables to contain our input values

		var width = jQuery('#contentbox-dialog input#contentbox-width').val();

		var bg_color = jQuery('#contentbox-dialog input#contentbox-bgcolor').val();

		var b_color = jQuery('#contentbox-dialog input#contentbox-bcolor').val();

		var style = jQuery('#contentbox-dialog select#contentbox-bstyle').val();

		var top = jQuery('#contentbox-dialog select#contentbox-b-twidth').val();		 

		var right = jQuery('#contentbox-dialog select#contentbox-b-rwidth').val();

		var bottom = jQuery('#contentbox-dialog select#contentbox-b-bwidth').val();

		var left = jQuery('#contentbox-dialog select#contentbox-b-lwidth').val();

		var radius = jQuery('#contentbox-dialog select#contentbox-radius').val();	 

 

		var output = '';

 

		// setup the output of our shortcode

		output = '[wpgfxm_contentbox ';

			output += 'width="' + width + '%" ';

			output += 'bg_color="#' + bg_color + '" ';

			output += 'b_color="#' + b_color + '" ';

			output += 'style="' + style + '" ';

			output += 'top="' + top + '" ';

			output += 'right="' + right + '" ';

			output += 'bottom="' + bottom + '" ';

			output += 'left="' + left + '" ';

			output += 'radius="' + radius + '"';

			output += ']';

			output += 'Add Content Here';

			output += '[/wpgfxm_contentbox]';



		tinyMCEPopup.execCommand('mceInsertContent', false, output);

 

		// Return

		tinyMCEPopup.close();

	}

};

tinyMCEPopup.onInit.add(ButtonDialog.init, ButtonDialog);

</script>



</head>



<body>

	<div id="contentbox-dialog">

		<form action="/" method="get" accept-charset="utf-8">

			<div id="contentbox-note">

			<p>Customize Your Content Box</p>

			</div>

			<div>

				<label for="contentbox-width">Box Width</label>

				<input type="text" name="contentbox-width" value="80" id="contentbox-width" /> %

			</div>

			<div>

				<label for="contentbox-bgcolor">Background Color</label>

				<input type="text" name="contentbox-bgcolor" value="f1f8fb" id="contentbox-bgcolor" class="wpgfxm_color" />

			</div>

			<div>

				<label for="contentbox-bcolor">Border Color</label>

				<input type="text" name="contentbox-bcolor" value="c1d2d9" id="contentbox-bcolor" class="wpgfxm_color" />

			</div>

			<div>

				<label for="contentbox-bstyle">Border Style</label>

				<select name="contentbox-bstyle" id="contentbox-bstyle">

					<option value="solid">None</option>

					<option value="solid" selected="selected">Solid</option>

					<option value="dashed">Dashed</option>

					<option value="dotted">Dotted</option>

					<option value="double">Double</option>

					<option value="groove">Groove</option>

					<option value="ridge">Ridge</option>

					<option value="inset">Inset</option>

					<option value="outset">Outset</option>

				</select>

			</div>

			<div>

				<label for="contentbox-b-twidth">Border Top Width</label>

				<select name="contentbox-b-twidth" id="contentbox-b-twidth">

					<option value="none">None</option>

					<option value="1px" selected="selected">1px</option>

					<option value="2px">2px</option>

					<option value="3px">3px</option>

					<option value="4px">4px</option>

					<option value="5px">5px</option>

					<option value="6px">6px</option>

					<option value="7px">7px</option>

					<option value="8px">8px</option>

					<option value="9px">9px</option>

					<option value="10px">10px</option>

				</select>

			</div>

			<div>

				<label for="contentbox-b-rwidth">Border Right Width</label>

				<select name="contentbox-b-rwidth" id="contentbox-b-rwidth">

					<option value="none" selected="selected">None</option>

					<option value="1px">1px</option>

					<option value="2px">2px</option>

					<option value="3px">3px</option>

					<option value="4px">4px</option>

					<option value="5px">5px</option>

					<option value="6px">6px</option>

					<option value="7px">7px</option>

					<option value="8px">8px</option>

					<option value="9px">9px</option>

					<option value="10px">10px</option>

				</select>

			</div>

			<div>

				<label for="contentbox-b-bwidth">Border Bottom Width</label>

				<select name="contentbox-b-bwidth" id="contentbox-b-bwidth">

					<option value="none">None</option>

					<option value="1px" selected="selected">1px</option>

					<option value="2px">2px</option>

					<option value="3px">3px</option>

					<option value="4px">4px</option>

					<option value="5px">5px</option>

					<option value="6px">6px</option>

					<option value="7px">7px</option>

					<option value="8px">8px</option>

					<option value="9px">9px</option>

					<option value="10px">10px</option>

				</select>

			</div>

			<div>

				<label for="contentbox-b-lwidth">Border Left Width</label>

				<select name="contentbox-b-lwidth" id="contentbox-b-lwidth">

					<option value="none" selected="selected">None</option>

					<option value="1px">1px</option>

					<option value="2px">2px</option>

					<option value="3px">3px</option>

					<option value="4px">4px</option>

					<option value="5px">5px</option>

					<option value="6px">6px</option>

					<option value="7px">7px</option>

					<option value="8px">8px</option>

					<option value="9px">9px</option>

					<option value="10px">10px</option>

				</select>

			</div>

			<div>

				<label for="contentbox-radius">Border Radius</label>

				<select name="contentbox-radius" id="contentbox-radius">

					<option value="0px" selected="selected">0px</option>

					<option value="3px">3px</option>

					<option value="5px">5px</option>

					<option value="10px">10px</option>

					<option value="15px">15px</option>

					<option value="20px">20px</option>

					<option value="25px">25px</option>

					<option value="30px">30px</option>

					<option value="35px">35px</option>

					<option value="40px">40px</option>

					<option value="45px">45px</option>

					<option value="50px">50px</option>

				</select>

			</div>

			<div class="get-full">

				<p><strong>You are using the FREE version of WP Graphix Magic!</strong> To get the <strong>FULL version</strong> which contains dozens more graphics, options, and shortcodes... Grab your copy at <a href="http://www.wpgraphixmagic.com" title="WP Graphix Magic" target="_blank">www.wpgraphixmagic.com</a>!</p>

			</div>

			<div>	

				<a href="javascript:ButtonDialog.insert(ButtonDialog.local_ed)" id="insert" style="display:block; line-height:24px;">Insert</a>

			</div>

		</form>

	</div>

</body>

</html>